﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace soutez_521
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool fileOk = false;
        private bool timeOk = true;
        private DateTime time;

        public MainWindow()
        {
            InitializeComponent();
        }

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = false;

            if (dialog.ShowDialog().Value)
            {
                this.filePath.Text = dialog.FileName;
                using (StreamReader sr = new StreamReader(dialog.OpenFile()))
                {
                    string content = await sr.ReadToEndAsync();
                    content = content.Replace("\r\n", "\n");

                    string[] lines = content.Split('\n');
                    long tmp1;
                    int tmp2;

                    bool ok = true;

                    for (int i = 0; i < 8; i++)
                    {
                        if (lines[i].Length != 8 || !Int32.TryParse(lines[i], out tmp2))
                            ok = false;
                    }

                    for (int i = 8; i < lines.Length; i++)
                    {
                        if (lines[i] != String.Empty)
                            if (!Int64.TryParse(lines[i], out tmp1))
                                ok = false;
                    }

                    this.fileOk = ok;

                    if (!ok)
                    {
                        this.filePath.Text = String.Empty;
                    }

                    this.playButton.IsEnabled = this.fileOk && this.timeOk;
                }
            }
        }

        private void timeBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            string time = this.timeBox.Text;
            bool ok = true;
            int tmp1, tmp2;

            if (time.Count(ch => ch == ':') != 1)
            {
                ok = false;   
            }
            else
            {
                string[] parts = time.Split(':');
                if (Int32.TryParse(parts[0], out tmp1) && Int32.TryParse(parts[1], out tmp2) && parts[0] != String.Empty && parts[1] != String.Empty)
                {
                    ok = true;
                    this.time = new DateTime(2000, 1, 1, 0, tmp1, tmp2);
                }
                else
                    ok = false;
            }

            if (this.useTime.IsChecked.Value)
            {
                this.timeOk = ok;

                this.playButton.IsEnabled = this.fileOk && this.timeOk;
            }
        }

        private void RadioButton_Checked(object sender, RoutedEventArgs e)
        {
            this.timeOk = true;
            this.time = new DateTime(0);

            if (this.playButton != null)
                this.playButton.IsEnabled = this.fileOk && this.timeOk;
        }

        private void RadioButton_Checked_1(object sender, RoutedEventArgs e)
        {
            string time = this.timeBox.Text;
            bool ok = true;
            int tmp1, tmp2;

            if (time.Count(ch => ch == ':') != 1)
            {
                ok = false;
            }
            else
            {
                string[] parts = time.Split(':');
                if (Int32.TryParse(parts[0], out tmp1) && Int32.TryParse(parts[1], out tmp2) && parts[0] != String.Empty && parts[1] != String.Empty)
                {
                    ok = true;
                    this.time = new DateTime(2000, 1, 1, 0, tmp1, tmp2);
                }
                else
                    ok = false;
            }

            this.timeOk = ok;

            this.playButton.IsEnabled = this.fileOk && this.timeOk;
        }

        private void playButton_Click(object sender, RoutedEventArgs e)
        {
            PlayWindow playWindow = new PlayWindow(this.filePath.Text, this.time);
            playWindow.Show();
            this.Close();
        }
    }
}
